using System;
class Program
{
    static void Main()
    {
        Console.Write("");
        string ulaz = Console.ReadLine();
        string[] nm = ulaz.Split(' ');
        long n = Convert.ToInt64(nm[0]);
        long m = Convert.ToInt64(nm[1]);
        long[] sorok = new long[n];
        long[]fobbunalmak=new long[5];
        for (long i = 0; i < n; i++)
        {
            Console.Write("");
            sorok[i] = Convert.ToInt64(Console.ReadLine());
        }

        //-----------egyikopcio------------------------------------
        long sor,oszlop;

       char [,]matrix=new char[n,m];
       for (sor = 0; sor < n; sor++)
       {
           for (oszlop = 0; oszlop < m; oszlop++)
           {
               if(oszlop<sorok[sor])
                   matrix[sor,oszlop]='#';
               else
                   matrix[sor, oszlop] = '.';
           }
       }

       for (sor = 0; sor < n; sor++)
       {
           for (oszlop = 0; oszlop < m; oszlop++)
           {
               if(matrix[sor,oszlop]=='#' && matrix[sor,m-1]=='#')
                   matrix[sor,oszlop]='.';
                   
           }
       }
       

        long hastag=0,pont=0;
        long unalom = 0; 

       for (oszlop = 0; oszlop < m; oszlop++)
       {
           for (sor = 0; sor < n; sor++)
           {
               if (matrix[sor,oszlop] == '#')
                   hastag++;
               else
                   pont++;
           }
           unalom+=(pont*hastag);
           hastag = 0;
           pont = 0;
       }

       fobbunalmak[0] = unalom;


       //-----------masikopciok------------------------------------
       long pontokszama=0;
        for (sor = 0; sor < n; sor++)
       {
           for (oszlop = 0; oszlop < m; oszlop++)
           {
               if (matrix[sor, oszlop] == '.')
                   pontokszama++;

           }
       }
            fobbunalmak[1]=pontokszama;
            fobbunalmak[2]=pontokszama-2;



            long megegy = 0;
            for (long i = 0; i < n; i++)
            {
                if (sorok[i] == m)
                    megegy += 0;
                else
                    megegy += (m - sorok[i]);
            }

            fobbunalmak[3] = megegy;
            fobbunalmak[4] = 100;

            long min = fobbunalmak[0];
            for (long x = 0; x < 5; x++)
                if (fobbunalmak[x] < min)
                    min = fobbunalmak[x];

                Console.Write(min.ToString());
       Console.ReadKey();
    }
}